function count=updown1(N)
% function count=updown1(N)
% up-down algorithm: Let N be a positive integer. If N is even, divide it
% by 2. But if it is odd, multiply it by 3 and add 1. Repeat until N 
% becomes 1. 
% Input positive integer number N
% Output: count is the number of repetitions needed to converge to 1
% Modified from the book Mastering Matlab 7
% Modified by Jutta Kretzberg for Matlab course for PhD students, 
% WS 2010/2011: http://www.sinnesphysiologie.uni-oldenburg.de/50246.html
    
%% test function input:
% N should be a positive integer scalar
if ~exist('N','var') || ~isnumeric(N) || ~isscalar(N) || round(N)~=N || N<1   
   warning('Input N should be a scalar positive integer value. Set N=25.') 
   N = 25;
end

%% up-down-sequence
count = 0;                  % iteration count
while N>1
   if rem(N,2)==0           % even numbers have remainder 0
      N = N/2;
      count = count+1;
   else                     % odd numbers
      N = 3*N+1;
      count = count+1;
   end
end