% script updown_perfomance tests the performance of different updown 
% solutions
% Written by Jutta Kretzberg for Matlab course for PhD students, 
% WS 2010/2011: http://www.sinnesphysiologie.uni-oldenburg.de/50246.html


clear all
profile on

Nums=1:3000;

% basic updown sequence 
Counts2=updown2(Nums);

% basic updown sequence using function calls of updown1
Counts2f=updown2f(Nums);

% updown sequence with two steps together for odd numbers 
Counts2a=updown2a(Nums);

% updown sequence with two steps together for odd numbers  
% using function calls of updown1a
Counts2af=updown2af(Nums);

% updown sequence with two steps together for odd numbers  
% using calls of sub-function local_updown1a
Counts2alf=updown2asubfunc(Nums); 

% updown sequence with two steps together for odd numbers  
% using calls of nested sub-function subfunc_updown1a
Counts2anf=updown2anestedfunc(Nums); 


% updown sequence with two steps together for odd numbers  
% and pre-allocated vector counts
Counts2a_prefed=updown2a_predef(Nums);

% updown sequence using vectorized solution
Counts_vector=updown_vector(Nums);

% updown sequence using optimized vectorized solution without rem function
Counts_vector=updown_vector_opt(Nums);

profile viewer          % opens the profiler GUI or
						% refreshes the window if it 
                        % is already open. 

